(****************************************************************************
                                                                            
     ACHTUNG  !!!  Bei Erweiterungen im Datenfile 8080-Z80.DAT unbegingt    
                   die alphabetische Reihenfolge einhalten, da der Such-    
                   algorithmus den Eintrag nich identifizieren kann.        
                   Beispiel : Ich hatte den Eintrag JMP                     
                                                    JP                      
                                                    OP   beim abschreiben   
                   }bersehen und als ich das bemerkte, an der falschen      
                   Stelle einsortiert. (nach JC und nicht nach JM)          
                   Ich habe mich dann gewundert, warum JMP trotzdem noch    
                   Label erkannt wurde und nicht als Opcode und siehe da,   
                   nachdem ich JMP richtig einsortiert hatte, war alles klar
                   Au~erdem darf und MU~ ein Dateineintrag nur das      
                   Format <alter Opcode>                                    
                          <neuer Opcode>
                          <Code Typ    >    haben, alles andere produziert
                   Mist !!!!!!!!!

      Nochmal zum Labelcheck. Ist diese Option eingeschaltet, so wird an 
      jedes Wort, das nicht als Kommentar, Opcode oder Operand erkennbar
      ist , ein : angeh{ngt. 

*****************************************************************************)



Program Uebersetzung_von_8080_nach_Z80;
(*$U+*)
const tab     = 9;
      wlen    = 12;
      linlen  = 90;
      max     = 108;
      maxmac  = 50;

type strings  = String[linlen];
     alfa     = String[wlen];
     option   = (noop,op,op8,op16,exad,rst,sta,stax,shld,ldax);
     oldnew   = Record
                  new : alfa;
                  old : alfa;
                  opt : option
                End;

Var mnem    : Array[1..max] of oldnew;
    rsts    : Array[0..7] of alfa;
    mactab  : Array[1..maxmac] of String[20];
    data,
    old,new : Text;
    eop,
    plab,
    found   : Boolean;
    instr   : strings;
    position,
    cc, mc,
    olc,nlc : Integer;
    status  : option;

Procedure error ( msg : strings );
Begin
  write('***** Fehler --- ',msg,' in Quellzeile #',olc:4);
  writeln('    ,    Zielzeile #',nlc:4);
End;

Procedure getword ( Var str,test : strings );
Var i : Integer;
    ch: Char;

  Procedure newstr;
  Var tmp : strings;
  Begin
    cc := Pred(cc);
    tmp := Copy(str,1,cc);
    While (cc < length(str)) and (str[Succ(cc)] <> '!') do
    Begin
      cc := Succ(cc);
      tmp[cc] := str[cc];
    End;
    Delete(str,1,cc);
    While (str[1] <= '!') and (length(str) > 0) do delete(str,1,1);
    While (tmp[cc] <= '!') and (0 < cc) do cc := Pred(cc);
    tmp[0] := chr(cc);
    writeln(new,tmp);
    nlc := Succ(nlc);
    While (length(str) < 1) and not eof(old) do
    Begin
      readln(old,str);
      olc := Succ(olc);
      if length(str) < 1 then
      Begin
        writeln(new,str);
        nlc := Succ(nlc);
      End;
    End;
    if length(str) < 1 then eop := True;
    cc := 1;
    ch := upcase(str[cc])
  End;

  Procedure newline;
  Var temp : strings;
      i    : Integer;
  Begin
    i := cc;
    temp := copy(str,1,cc-1);
    Repeat cc := Pred(cc) until (temp[cc] > '!') or (cc<1);
    temp[0] := chr(cc);
    writeln(new,temp);
    nlc := Succ(nlc);
    delete(str,1,i);
    While (str[1] <= '!') and (length(str) > 0) do delete(str,1,1);
    cc := 1;
    ch := upcase(str[cc]);
  End;

Begin  (* getword *)
  ch := upcase(str[cc]);
  if length(str) < cc then newstr;
  While (ch = ';') or (ch <= '!') and not eop do
  Begin
    if (ch = ';') or (length(str) <= cc) then newstr
                                         else if ch = '!' then newline
                                                          else
                                                          Begin
                                                            delete(str,cc,1);
                                                            ch:=upcase(str[cc])
                                                          End;
  End;
  i := 0;
  While (ch > '!') and not (ch in [';',':']) and (length(str) >= cc) do
  Begin
    i := Succ(i);
    test[i] := ch;
    delete(str,cc,1);
    if str[cc] = '$' then delete(str,cc,1);
    ch := upcase(str[cc])
  End;
  While (ch = ':') and (length(str) >= cc) do
  Begin
    i := Succ(i);
    test[i] := ch;
    delete(str,cc,1);
    ch := str[cc]
  End;
  test[0] := chr(i);
End;      (* getword *)

Procedure getopr ( Var str,opr : strings );
Var i,oi : Integer;
    exit : Boolean;

  Procedure word;
  Begin
    Repeat
      i := succ(i);
      opr[i] := upcase(str[cc]);
      delete(str,cc,1);
      if str[cc] = '$' then delete(str,cc,1);
    until not (upcase(str[cc]) in ['.','#','?'..'Z'
                                      ,'_','0'..'9']) or (cc>length(str))
  End;

  Procedure chars;
  Var delim : char;
  Begin
    delim := str[cc];
    Repeat
      i := Succ(i);
      opr[i] := str[cc];
      delete(str,cc,1)
    until (str[cc] = delim) or (cc >= length(str));
    i := Succ(i);
    opr[i] := str[cc];
    delete(str,cc,1)
  End;

  Procedure numbers;
  Begin
    Repeat
      if str[cc] = '$' then delete(str,cc,1);
      i := Succ(i);
      opr[i] := upcase(str[cc]);
      delete(str,cc,1)
    until not (upcase(str[cc]) in ['0'..'9','A'..'Z','$']) or (cc>length(str))
  End;

  Procedure operator;
  Begin
    i := succ(i);
    opr[i] := str[cc];
    delete(str,cc,1)
  End;

Begin   (* getopr *)
  i := 0;
  oi := 0;
  exit := false;
  While (str[cc] < '!') and (cc <= length(str)) do delete(str,cc,1);
  While (str[cc]<>'!') and (cc<=length(str)) and (str[cc]<>';') and not exit do
  Begin
    if upcase(str[cc]) in [ '?'..'Z','_' ] then word
      else if str[cc] in [ '0'..'9' ] then numbers
        else if str[cc] in [ '''','"'  ] then chars
          else if str[cc] in [ '$','&','('..'/','<'..'>' ] then operator;
    While (str[cc] < '!') and (cc <= length(str)) do
    Begin
      i := Succ(i);
      opr[i] := str[cc];
      delete(str,cc,1);
    End;
    if i <= oi then
    Begin
      error(' im Operand');
      exit := True
    End;
    oi := i
  End;
  While(i > 0) and (opr[i] < '!') do i:=Pred(i);
  opr[0] := chr(i);
End;

Procedure search (Var test : strings;   Var k : Integer;
                  Var found : Boolean                      );
Var i,j : Integer;
Begin
  i := 1;
  j := max;
  Repeat
    k := (i + j) shr 1;
    if test <= mnem[k].old then j:= Pred(k);
    If test >= mnem[k].old then i := Succ(k);
  until i > j;
  if Pred(i) > j then
  Begin
    found := true;
    test := mnem[k].new;
  End
  else found := false
End;

Procedure checkop ( position : Integer; Var test : strings );

  Procedure change_m (Var opr : strings);
  Var cpos,mpos : 0..wlen;
  Begin
    mpos := Pos('M',opr);
    cpos := Pos(',',opr);
    if mpos<>0 then if (mpos<cpos) or (length(opr)=3) or (length(opr)=1) then
                    Begin
                      delete(opr,mpos,1);
                      insert('(HL)',opr,mpos)
                    End;
  End;

  Procedure exadd ( Var opr : strings );
  Begin
    insert('(',opr,1);
    opr := concat(opr,')');
  End;

  Procedure change_exreg ( Var opr : strings );
  Begin
    case opr[1] of
      'B' : insert('C',opr,2);
      'D' : insert('E',opr,2);
      'H' : insert('L',opr,2);
      'P' : if (opr[2] = 'S') and (opr[3] = 'W') then
            Begin
              delete(opr,1,3);
              insert('AF',opr,1)
            End;
    End;
  End;

Begin  (* checkop *)
  case mnem[position].opt of
    op8  : change_m(test);
    op16 : change_exreg(test);
    exad : exadd(test);
    sta  : Begin
             exadd(test);
             test := concat(test,',A')
           End;
    stax : Begin
             if test = 'B' then test := '(BC),A'
                           else if test = 'D' then test := '(DE),A';
           End;
    shld : Begin
             exadd(test);
             test := concat(test,',HL');
           End;
    ldax : Begin
             change_exreg(test);
             exadd(test)
           End;
    rst  : if (length(test) = 1) and (test[1] in ['0'..'7']) then
                                              test := rsts[ord(test[1]) - 48];
  End;
End;

Function makro ( word : strings ) : Boolean;
Var  i : Integer;
Begin
  i := 1;
  While (mc > i) and (mactab[i] <> word) do i:=Succ(i);
  makro := mactab[i] = word
End;

Procedure enter ( word : strings );
Begin
  mactab[mc] := word;
  mc := Succ(mc);
  if mc > maxmac then
  Begin
    error('Makrotabelle l{uft }ber');
    mc := 1
  End;
End;

Function setup : Boolean;
Var name : string[20];
    ch   : char;
    i,j,k: Boolean;
Begin
  Repeat
    writeln;
    write('Name der Quelldatei ?  : ');
    readln(name);
    assign(old,name);
    write('Name der Zieldatei ?  : ');
    readln(name);
    assign(new,name);
    assign(data,'8080-Z80.DAT');
    write('Mit Label-check  ? (J/N)  : ');
    readln(ch);
    plab := ch in ['J','j'];
  (*$I-*)
    reset(old);
    i := Ioresult <> 0;
    if i then Writeln('Quelldatei nicht gefunden !',chr(7));
    reset(new);
    j := ioresult = 0;
    if j then Writeln('Zieldatei existiert schon ',chr(7));
    if not j then rewrite(new);
    k := IOresult <> 0;
    if k then writeln('Direktory voll !!',chr(7));
  until not(i or j or k);
  reset(data);
(*$I+*)
  k := IOresult = 0;
  If not k then writeln('8080-Z80.DAT nicht gefunden !!!',chr(7));
  setup := k
End;

Procedure initary;
Var option_str : alfa;
Begin
  position := 1;
  while (not eof(data)) and (position <= max) do
  Begin
    with mnem[position] do
    Begin
      readln(data,old);
      readln(data,new);
      readln(data,option_str);
      if Option_str = 'NOOP' then opt := noop
        else if Option_str = 'OP' then opt := op
          else if Option_str = 'OP8'  then opt := op8
            else if Option_str = 'OP16' then opt := op16
              else if Option_str = 'EXAD' then opt := exad
                else if Option_str = 'STA'  then opt := sta
                  else if Option_str = 'STAX' then opt := stax
                    else if Option_str = 'SHLD' then opt := shld
                      else if Option_str = 'LDAX' then opt := ldax
                        else if Option_str = 'RST'  then opt := rst;
      readln(data);
      position := Succ(position)
    End
  End;
  rsts[0] := '0';  rsts[1] := '8';  rsts[2] := '10H'; rsts[3] := '18H';
  rsts[4] := '20H';  rsts[5] := '28H';  rsts[6] := '30H'; rsts[7] := '38H';
End;

Procedure work;
Var test : strings;

  Procedure newwrite ( Var str,test : strings );
  Begin
    if pos('^',test) > 0 then test[pos('^',test)] := chr(tab);
    if cc > length(str) then str := concat(str,test)
                        else insert(test,str,cc);
    cc := cc+length(test);
    if cc < length(str) then
    Begin
      insert(chr(tab),str,cc);
      cc := Succ(cc)
    End;
  End;

  Function nextword ( line,sstr : strings ) : Boolean;
  Var result : Boolean;
      li,si  : Integer;
  Begin
    li := 1;
    si := 1;
    result := false;
    While not(line[li] in ['A'..'Z','a'..'z'])
                                         and (li<length(line)) do li:=Succ(li);
    While (upcase(line[li]) = upcase(sstr[si])) and (li<=length(line))
                                                             and not result do
                                    If si = length(sstr) then result := true
                                                         else
                                                         Begin
                                                           li := Succ(li);
                                                           si := Succ(si)
                                                         End;
    if result and (line[Succ(li)] > '!') then result := False;
    nextword := result
  End;

  Procedure labtst;
  Begin
    if plab then
      if Nextword(instr,'EQU') or NextWord(instr,'SET') then
      Begin
        if test[length(test)] = ':' then delete(test,length(test),1);
      End
      else
        if test[length(test)] <> ':' then test := concat(test,':');
  End;

  Procedure poper;
  Var operand : strings;
      b : byte;
  Begin
    if pos('^',test) <> 0 then
    Begin
      operand := copy(test,pos('^',test),length(test)-pos('^',test)+1);
      delete(test,pos('^',test),length(test)-pos('^',test)+1);
    End
    else operand := '';
    newwrite(instr,test);
    getopr(instr,test);
    checkop(position,test);
    test := concat(operand,test);
    b := pos('^',test);
    if b <> 0 then delete(test,b,1);
  End;

Begin  (* work *)
  while not eop do
  Begin
    getword(instr,test);
    search(test,position,found);
    status := mnem[position].opt;
    if not found then
    Begin
      if nextword(instr,'MACRO') then enter(test)
                                 else if not makro(test) then labtst
                                                         else
                                                         Begin
                                                           status := op;
                                                           found := true
                                                         End;
    End
    else if cc = 1 then
    Begin
      insert(chr(tab),instr,1);
      cc := Succ(cc)
    End;
    if (status <> noop) and found then poper;
    newwrite(instr,test);
  End;
End;

Procedure stat;
Begin
  writeln;
  writeln(']bersetzung beendet');
  writeln(olc:5,'  Zeilen 8080 Assemblertext,');
  writeln(nlc:5,'  Zeilen Z80  Assemblertext,');
  writeln(Pred(mc):5,'  Makros erkannt');
End;

Begin    (* MAIN *)
  Clrscr;
  write(' ]bersetzerprogramm 8080 --> Z80');
  writeln('              (Quelle : C',chr(39),'t 5/85 Seiten 94-96)');
  if setup then
  Begin
    initary;
    eop := false;
    cc := 1;
    mc := 1;
    olc := 1;
    nlc := 0;
    readln(old,instr);
    writeln(new,'.Z80');
    nlc := Succ(nlc);
    work;
    stat;
    close(old);
    close(new);
    close(data);
  End;
End.







